Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math.stat.descriptive.moment
Class ThirdMoment

    java.lang.Object
      org.apache.commons.math.stat.descriptive.AbstractUnivariateStatistic
          org.apache.commons.math.stat.descriptive.AbstractStorelessUnivariateStatistic
              org.apache.commons.math.stat.descriptive.moment.FirstMoment
                  org.apache.commons.math.stat.descriptive.moment.SecondMoment
                      org.apache.commons.math.stat.descriptive.moment.ThirdMoment

All Implemented Interfaces:
  Serializable, StorelessUnivariateStatistic, UnivariateStatistic

Direct Known Subclasses:
  FourthMoment

    public class ThirdMoment

extends SecondMoment
implements Serializable

Computes a statistic related to the Third Central Moment. Specifically, what is computed is the sum of cubed deviations from the sample mean.

The following recursive updating formula is used:

Let

- dev = (current obs - previous mean)
- m2 = previous value of `SecondMoment`
- n = number of observations (including current obs)

Then

new value = old value - 3 * (dev/n) * m2 + (n-1) * (n -2) * (dev^3/n^2)

Returns `Double.NaN` if no data values have been added and returns `0` if there is just one value in the data set.

Note that this implementation is not synchronized. If multiple threads access an instance of this class concurrently, and at least one of the threads invokes the `increment()` or `clear()` method, it must be synchronized externally.

Version:
  $Revision: 811685 $ $Date: 2009-09-05 19:36:48 +0200 (sam. 05 sept. 2009) $
See Also:
  Serialized Form

Field Summary
`protected double` | `m3` third moment of values that have been added
`protected double` | `nDevSq` Square of deviation of most recently added value from previous first moment, normalized by previous sample size.

Fields inherited from class org.apache.commons.math.stat.descriptive.moment.SecondMoment
`m2`

Fields inherited from class org.apache.commons.math.stat.descriptive.moment.FirstMoment
`dev, m1, n, nDev`

Constructor Summary
`ThirdMoment()` Create a FourthMoment instance
`ThirdMoment(ThirdMoment original)` Copy constructor, creates a new `ThirdMoment` identical to the `original`

Method Summary
`void` | `clear()` Clears the internal state of the Statistic
`ThirdMoment` | `copy()` Returns a copy of the statistic with the same internal state.
`static void` | `copy(ThirdMoment source, ThirdMoment dest)` Copies source to dest.
`double` | `getResult()` Returns the current value of the Statistic.
`void` | `increment(double d)` Updates the internal state of the statistic to reflect the addition of the new value.

Methods inherited from class org.apache.commons.math.stat.descriptive.moment.SecondMoment
`copy`

Methods inherited from class org.apache.commons.math.stat.descriptive.moment.FirstMoment
`copy, getN`

Methods inherited from class org.apache.commons.math.stat.descriptive.AbstractStorelessUnivariateStatistic
`equals, evaluate, evaluate, hashCode, incrementAll, incrementAll`

Methods inherited from class org.apache.commons.math.stat.descriptive.AbstractUnivariateStatistic
`evaluate, getData, getDataRef, setData, setData, test, test`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### m3

    protected double m3

  third moment of values that have been added

### nDevSq

    protected double nDevSq

  Square of deviation of most recently added value from previous first moment, normalized by previous sample size. Retained to prevent repeated computation in higher order moments. nDevSq = nDev * nDev.

Constructor Detail

### ThirdMoment

    public ThirdMoment()

  Create a FourthMoment instance

### ThirdMoment

    public ThirdMoment(ThirdMoment original)

  Copy constructor, creates a new `ThirdMoment` identical to the `original`

  Parameters:
    `original` - the `ThirdMoment` instance to copy

Method Detail

### increment

    public void increment(double d)

  Updates the internal state of the statistic to reflect the addition of the new value.

  Specified by:
    `increment` in interface `StorelessUnivariateStatistic`
  Overrides:
    `increment` in class `SecondMoment`
  Parameters:
    `d` - the new value.

### getResult

    public double getResult()

  Returns the current value of the Statistic.

  Specified by:
    `getResult` in interface `StorelessUnivariateStatistic`
  Overrides:
    `getResult` in class `SecondMoment`
  Returns:
    value of the statistic, `Double.NaN` if it has been cleared or just instantiated.

### clear

    public void clear()

  Clears the internal state of the Statistic

  Specified by:
    `clear` in interface `StorelessUnivariateStatistic`
  Overrides:
    `clear` in class `SecondMoment`

### copy

    public ThirdMoment copy()

  Returns a copy of the statistic with the same internal state.

  Specified by:
    `copy` in interface `StorelessUnivariateStatistic`
  Specified by:
    `copy` in interface `UnivariateStatistic`
  Overrides:
    `copy` in class `SecondMoment`
  Returns:
    a copy of the statistic

### copy

    public static void copy(ThirdMoment source,
                            ThirdMoment dest)

  Copies source to dest.

  Neither source nor dest can be null.

  Parameters:
    `source` - ThirdMoment to copy
    `dest` - ThirdMoment to copy to
  Throws:
    `NullPointerException` - if either source or dest is null

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2011 The Apache Software Foundation. All Rights Reserved.